<?php

/**
 * estado_caja actions.
 *
 * @package    cartera
 * @subpackage estado_caja
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class estado_cajaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_ESTADO_CAJA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_ESTADO_CAJA' =>
        array(
            'id_estado_caja' => 'id_estado_caja',
            'id_punto_venta' => 'id_punto_venta',
            'id_caja' => 'id_caja',
            'estado' => 'estado',
            'sesion' => 'sesion',
            'fecha_estado' => 'fecha_estado',
            'cajero' => 'cajero',
            'num_factura' => 'num_factura',
            'valor_base' => 'valor_base',
            'actual' => 'actual'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_ESTADO_CAJA' => array(
            'id_estado_caja,a' => array('!=' => array(-1)),
            'id_estado_caja,b' => array('=' => array('id_estado_caja')),
            'estado' => array('=' => array('estado')),
            'id_punto_venta' => array('=' => array('id_punto_venta')),
            'id_caja' => array('=' => array('id_caja')),
            'cajero' => array('=' => array('cajero')),
            'sesion' => array('=' => array('sesion')),
            'actual' => array('=' => array('actual')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'sesion'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_estado_caja'; //identificador de la tabla
    protected $id_names = array('id_estado_caja'); //llave primaria
    protected $field_names = array('id_punto_venta', 'id_caja', 'estado', 'sesion', 'fecha_estado', 'cajero', 'num_factura', 'valor_base', 'actual'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_ESTADO_CAJA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    /*
     * campos para fecha sistema con hora
     */
    protected $campo_fecha_sistema_hora = array(
        'fecha_estado'
    );


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_estado_caja'; //identificador unico de la tabla

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para add ESTADO CAJA
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        //manejo de errores
        try {

            $resultado = array();

            /*
             * Variables obligatorias
             */
            $id_caja = $request['id_caja'];
            $id_punto_venta = $request['id_punto_venta'];
            if ($request['estado'] == 'true') {
                $estado = 1;
            } else {
                $estado = 0;
            }
            $sesion = $request['sesion'];
            $cajero = $request['cajero'];
            $num_factura = $request['num_factura'];
            $valor_base = $request['valor_base'];
            if ($request['actual']) {
                $actual = 1;
            } else {
                $actual = 0;
            }


            /*
             * Obtener ultimo estado de la caja y punto de venta
             */
            //sentencia sql
            $sql = <<<EOD
select * from ca_caja_estado_actual
where
id_caja = $id_caja
and id_punto_venta = $id_punto_venta
EOD;

            //ejecuta el sql
            $result = CN_TABLE::executeSQL($sql);
            if ($result[0]['estado']) {
                $ant_estado = 1;
            } else {
                $ant_estado = 0;
            }

            /*
             * Estado de la caja no sea el mismo que se ba a crear
             * si esta abierta no se puede volver abrir o viceversa
             */
            $this->logMessage("[ESTADO CAJA] estados: " . $estado . " - " . $ant_estado);
            if ($estado != $ant_estado) {
                $this->logMessage("[ESTADO CAJA] si esta abierta no se puede volver abrir o viceversa");

                /*
                 * obtener la ultima aprobacion por caja/punto de venta
                 */
                //sentencia sql
                $sql = <<<EOD
select * from ca_aprob_caja
where
actual = 1
and id_caja = $id_caja
and id_punto_venta = $id_punto_venta
EOD;
                //ejecuta el sql
                $result = CN_TABLE::executeSQL($sql);

                //la caja posee aprobacion actual
                if (count($result) > 0) {

                    $fechaactual = strtotime(CN_TABLE::fechaSistema()); //fecha actual del sistema
                    $fechaevento = strtotime($result[0]['fecha_vencimiento']); //fecha de vigencia aprobacion
                    //fecha_vencimiento vigente aprobacion actual
                    if ($fechaactual <= $fechaevento) {
                        $this->logMessage("[ESTADO CAJA] fecha_vencimiento vigente aprobacion actual");


                        $num_aprob_ini = $result[0]['num_aprob_ini'];
                        $num_aprob_fin = $result[0]['num_aprob_fin'];

                        /*
                         * Consultar el consecutivo de la caja por punto de venta
                         */
                        //sentencia sql
                        $sql = <<<EOD
select * from ca_consecutivo_caja
where
id_caja = $id_caja
and id_punto_venta = $id_punto_venta
EOD;
                        //ejecuta el sql
                        $result = CN_TABLE::executeSQL($sql);

                        $consec_fac = $result[0]['consec_fac'];
                        $sesion_caja = $result[0]['sesion_caja'];


                        $validar_sec = false;
                        $mensaje = "[ESTADO CAJA] Verificar consecutivos de facturas.";

                        /**
                         * Consecutivo segun estado caja
                         */
                        //consecutivo de factura no mayor a numero de aprobacion final de la aprobacion de caja actual
                        if ($estado == 0) {
                            $this->logMessage("[ESTADO CAJA] La caja se va ha cerrar.");
                            $validar_sec = true;
                            $num_factura = $consec_fac;
                        } else {
                            $this->logMessage("[ESTADO CAJA] consecutivo de factura no mayor a numero de aprobacion final de la aprobacion de caja actual");

                            if ($consec_fac == 0) {

                                $validar_sec = true;
                                $num_factura = $num_aprob_ini;
                            } else if ($consec_fac == $num_aprob_fin) {

                                $mensaje = "[ESTADO CAJA] Consecutivo de factura NO mayor a numero de aprobacion final de la aprobacion de caja actual.";
                                $validar_sec = false;
                                $num_factura = 0;
                            } else {

                                $validar_sec = true;
                                $num_factura = $consec_fac + 1;
                            }
                        }


                        /*
                         * Validar si se guarda el registro segun consecutivo factura
                         */
                        if ($validar_sec) {
                            $this->logMessage("[ESTADO CAJA] Guardar registro.");

                            //si es abrir caja aumenta la sesion
                            if ($estado == 1) {
                                $sesion_caja = $sesion_caja + 1;
                            }


                            /*
                             * Guardar registro de estado caja
                             */
                            //sentencia sql
                            $sql = <<<EOD
Insert into CA_ESTADO_CAJA ( ID_ESTADO_CAJA, ID_PUNTO_VENTA, ID_CAJA, ESTADO, SESION, FECHA_ESTADO, CAJERO, NUM_FACTURA, VALOR_BASE, ACTUAL )
values ( null, $id_punto_venta, $id_caja, $estado, $sesion_caja, sysdate, $cajero, $num_factura, $valor_base, $actual )
EOD;

                            //ejecuta el sql
                            $result = CN_TABLE::executeSQL($sql);


                            // ultimo registro insertado CA_ESTADO_CAJA
                            $sql = <<<EOD
Select
*
From CA_ESTADO_CAJA
Where
id_caja = $id_caja
and id_punto_venta = $id_punto_venta
and id_estado_caja = (
    Select
    max(id_estado_caja)
    From CA_ESTADO_CAJA
    Where
    id_caja = $id_caja
    and id_punto_venta = $id_punto_venta
)
EOD;
                            //ejecuta y obtiene el resultado del sql
                            $result = CN_TABLE::executeSQL($sql);


                            /*
                             * INICIO variables por defecto para el registro de log
                             */ {
                                //obtiene el valor para su identificador unico
                                $id_tabla = $result[0]['id_estado_caja'];

                                //validar vigencia
                                $id_vigencia = 'null';
                                if ($this->has_vigencia) {
                                    if (isset($request['id_anhos'])) {
                                        $id_vigencia = $request['id_anhos'];
                                    }
                                }

                                //validar centro de operacion
                                $id_cen_op = 'null';
                                if ($this->has_cen_op) {
                                    if (isset($request['id_cen_op'])) {
                                        $id_cen_op = $request['id_cen_op'];
                                    }
                                }

                                $id_cia = 'null';
                                if ($this->has_id_cia) {
                                    if (isset($request['id_cia'])) {
                                        $id_cia = $request['id_cia'];
                                    }
                                }

                                //obtener id maestro tabla
                                $id_mae_bd = CN_TABLE::consultarIdTablaBD('CA_ESTADO_CAJA');

                                //3 - indica operacion de adicion de registro
                                $id_ope_bd = 3;

                                //id del maestro tercero
                                $id_mae_ter = 1;
                                if (isset($request['id_username'])) {
                                    $id_mae_ter = $request['id_username'];
                                }
                                //el username desde qebsafiERP
                                $usuario = 'admin';
                                if (isset($request['username']) && $request['username'] != '') {
                                    $usuario = $request['username'];
                                }
                                //comando que identifica la funcionalidad
                                $comando = 'sin comando';
                                if (isset($request['comando'])) {
                                    $comando = $request['comando'];
                                }

                                /*
                                 * Construir observacion
                                 */
                                $observacion = "'Se adiciono id_estado_caja : " . $id_tabla . " desde la funcionalidad: " . $comando . "'";


                                $id_punto_venta_log = 'null';
                                if (isset($request['punto_venta_log'])) {
                                    $id_punto_venta_log = $request['punto_venta_log'];
                                }
                            }
                            /*
                             * FIN variables por defecto para el registro de log
                             */


                            /*
                             * registro de consulta en tabla de log
                             */
                            $sql = CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter, $usuario, $comando, $observacion, $id_punto_venta_log);


                            /*
                             * Cambio de actual a demas registros de caja y punto de venta
                             */
                            $sql = <<<EOD
UPDATE CA_ESTADO_CAJA SET ACTUAL = 0 WHERE ID_PUNTO_VENTA = $id_punto_venta AND ID_CAJA = $id_caja and id_estado_caja != $id_tabla
EOD;

                            //ejecuta el resultado del sql
                            CN_TABLE::executeSQL($sql);


                            //si es abrir caja aumenta la sesion - trigger listo
//                            if ($estado == 1) {
//                                /*
//                                 * Cambio de sesion consecutivo caja por caja y punto de venta
//                                 */
//                                $sql = <<<EOD
//UPDATE ca_consecutivo_caja SET sesion_caja = $sesion_caja WHERE ID_PUNTO_VENTA = $id_punto_venta AND ID_CAJA = $id_caja
//EOD;
//
//                                //ejecuta el resultado del sql
//                                CN_TABLE::executeSQL($sql);
//                            }
                            //Resultado para el Template
                            $this->list_data = $result;
                            $this->logMessage("[ESTADO CAJA] Registro nuevo estado caja.");
                        } else {

                            $this->status = 1;
                            $this->mensajeError = $mensaje;
                            $this->list_data = array();
                            $this->logMessage($mensaje);
                        }
                    } else {

                        $mensaje = "[ESTADO CAJA] Fecha de vigencia para la aprobacion esta vencida.";
                        $this->status = 1;
                        $this->mensajeError = $mensaje;
                        $this->list_data = array();
                        $this->logMessage($mensaje);
                    }
                } else {

                    $mensaje = "[CONSECUTIVO CAJA] La caja no posee aprobacion actual.";
                    $this->status = 1;
                    $this->mensajeError = $mensaje;
                    $this->list_data = array();
                    $this->logMessage($mensaje);
                }
            } else {

                $mensaje = "[ESTADO CAJA] La caja si esta abierta no se puede volver abrir o viceversa.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
